!Calculate characteristic points on bounding loop
subroutine revboundingloop(z_1bound, p_1bound, phi_soil, k0, w_soil, psi_soil, z_2bound, p_2bound, z_3bound)
	implicit none
	double precision, intent(in) :: z_1bound, p_1bound, phi_soil, k0, w_soil, psi_soil
	double precision, intent(out) :: z_2bound, p_2bound, z_3bound
	
	z_2bound = z_1bound	 - ((1+w_soil)*p_1bound)/k0 * (1+phi_soil)/(w_soil-phi_soil) 
	p_2bound = -phi_soil*p_1bound 
	z_3bound  = z_2bound - psi_soil*(z_1bound-z_2bound)
	
END subroutine revboundingloop
	
   


