function z_pmax = iterationHyperbolic(k0, w_soil,work_array)
    z_lastRev = work_array(9);
	z_1controlDeg = work_array(12);	
    p_1bound = work_array(17);
    p_lastRev = work_array(19);
    p_1controlDeg = work_array(21);
	
    error = -1;
	z = z_lastRev;	
    b = (z_1controlDeg - z_lastRev)/(p_1controlDeg - p_lastRev)- 1/k0;
	xi_controlP = (z_1controlDeg - z_lastRev)/(p_1controlDeg*(1+w_soil)*b); 	 
	while (error <= 0.0d0)
		z = z + 0.01;
		p =  p_lastRev + (z - z_lastRev) / (1/k0 + 1*(z-z_lastRev)/((1+w_soil)*p_1controlDeg*xi_controlP));
		error = p - p_1bound;		
	end 
	 z_pmax = z;     
end 