%Path 1-2
%Elastic Rebound
function  [p, kz, path, work_array]  =  path12(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back)
    z_1bound = work_array(6);
    p_1bound = work_array(17);
    z_2bound = work_array(7);
    z_prev = work_array(5);
    p = p_1bound + (z-z_1bound)/(1/k0 -1*(z-z_1bound)/((1+w_soil)*p_1bound));    
  
    A = 1/k0 -1*(z-z_1bound)/((1+w_soil)*p_1bound);
    kz = 1/A-1*(z_1bound-z)/((1+w_soil)*p_1bound*A^2);
    path =12;    
    if z <= z_2bound         
       [p, kz, path, work_array] = path23(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);
    end 
    if z > z_prev       
        [p, kz, path, work_array] = path121(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);
    end    
end