%Path 1-2-1;
%Reloading from path 2-3, 1-2 or from an arbitrary reversal within bounding loop
function [p, kz, path, work_array] = path121(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back)
    z_prev = work_array(5);
    z_lastRev = work_array(9);
    z_cubicRev = work_array(10);
    z_1controlDeg = work_array(12);
    z_pmax = work_array(13);
    p_prev = work_array(16);
    p_1bound = work_array(17);
    p_lastRev = work_array(19);
    p_cubicRev = work_array(20);
    p_1controlDeg = work_array(21);
    dp_backbone = work_array(23);
    path =121;    
    if z>=z_prev	
        if z >= z_1controlDeg
			 work_array(23) = dp_backbone + (p_1controlDeg-p_1bound);            
			[p, kz, path, work_array]  = path01(z, d, a_back, b_back, strength_mudline, strength_grad, work_array);
        end 	
        b = (z_1controlDeg - z_lastRev)/(p_1controlDeg - p_lastRev)- 1/k0;
        xi_controlP = (z_1controlDeg - z_lastRev)/(p_1controlDeg*(1+w_soil)*b)
		p = p_lastRev + (z - z_lastRev) / (1/k0 + 1*(z-z_lastRev)/((1+w_soil)*p_1controlDeg*xi_controlP));        
		a = 1/k0 + 1*(z-z_lastRev)/((1+w_soil)*p_1controlDeg*xi_controlP);
        kz = 1/a + 1*(z_lastRev -z)/((1+w_soil) *p_1controlDeg*xi_controlP*a^2);         
        z0 = (z_1controlDeg+z_cubicRev)/2;
        zm = (z_1controlDeg-z_cubicRev)/2;
        p_bound = (p_1controlDeg+p_cubicRev)/2 +(p_1controlDeg-p_cubicRev)/4*(3*(z-z0)/zm -((z-z0)/zm)^3);        
        if p>=p_bound && path ~= 0
			[p, kz, path, work_array]  = path321(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);             
		end 
		if p_lastRev == p_prev
			work_array(13) =  iterationHyperbolic(k0, w_soil,work_array);	
		end
		if p>p_1bound
            p=p_1bound;
			kz = 0;
        end 				
   else
        if p_prev>=p_1bound	
            work_array(6)= z_lastRev;
            work_array(17)  = p_lastRev;
            [work_array(7), work_array(18), work_array(8)] = revboundingloop(z_lastRev, p_lastRev, phi_soil, k0, w_soil, psi_soil);	
            [p, kz, path, work_array]  =  path12(z, work_array, d, a_back,b_back,strength_mudline,strength_grad, k0, w_soil);		
        end	
        [work_array(14), work_array(22), work_array(15)] = revboundingloop(z_pmax, p_lastRev, phi_soil, k0, w_soil, psi_soil);	
        [p, kz, path, work_array]  = path122(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);        
    end   
end