%Path 1-2-2;
%Unloading from path 3-1 or from an arbitrary reversal within bounding loop
function [p, kz, path, work_array] = path122(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back, b_back)
    z_prev = work_array(5);
    z_1bound = work_array(6);
    z_2bound = work_array(7);
    z_3bound = work_array(8);
    z_lastRev = work_array(9);
    z_pmax = work_array(13);
    z_2boundc  = work_array(14);
    z_3boundc = work_array(15);
    p_1bound = work_array(17);
    p_2bound = work_array(18);
    p_lastRev = work_array(19);
    p_2boundc = work_array(22);
   
    p = p_lastRev + (z-z_lastRev)/(1/k0 -1*(z-z_lastRev)/((1+w_soil)*p_1bound));
    A = 1/k0 -1*(z-z_lastRev)/((1+w_soil)*p_1bound);
    kz = 1/A-1*(z_lastRev-z)/((1+w_soil)*p_1bound*A^2);
    path = 122;   
	if z>z_prev	
		path = 121;
		[p, kz, path, work_array]  = path121(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back, b_back);
	else
		p_path12c  = p_1bound + (z_lastRev-z_1bound)/(1/k0 - 1*(z_lastRev-z_1bound)/((1+w_soil)*p_1bound));          
		if z_2bound<z && z_lastRev<=z_1bound && p_lastRev>=p_path12c
            p_path12  =  p_1bound + (z-z_1bound)/(1/k0 -1*(z-z_1bound)/((1+w_soil)*p_1bound));
           	if p<=p_path12	                
				path = 12;
				[p, kz, path, work_array]  =  path12(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);
			end 
		elseif z_3bound<z && z<=z_2bound && z_lastRev<z_1bound && p_lastRev>=p_path12c           
            z0 = (z_2bound + z_3bound)/2;
            zm = (z_2bound-z_3bound)/2;
            p_path23= p_2bound/2 +p_2bound/4*(3*(z-z0)/zm - ((z-z0)/zm)^3);	
           	if  p<=p_path23
				path = 23;
				[p, kz, path, work_array]  = path23(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);
			end 	
		elseif z_pmax>=z && z>z_2boundc            
			p_path12  =  p_1bound + (z-z_pmax)/(1/k0 -1*(z-z_pmax)/((1+w_soil)*p_1bound));	
            if p<=p_path12
               	p = p_path12;	
            end 
		elseif z_2boundc>z && z>z_3boundc
            z0 = (z_2boundc + z_3boundc)/2;
            zm = (z_2boundc-z_3boundc)/2;
            p_path23 = p_2boundc/2 + p_2boundc/4*(3*(z-z0)/zm - ((z-z0)/zm)^3);         
            if p<=p_path23
                 p = p_path23;
                [work_array(7), work_array(18), work_array(8)] = revboundingloop(z_pmax, p_1bound, phi_soil, k0, w_soil, psi_soil);
			end 	
        elseif z<=z_3bound           
              [p, kz, path, work_array] = path30(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);
         elseif z<=z_3boundc 
            p = 0;
            kz = 0;               
		end 
    end 
end 