%Path 2-3
%Partial riser-soil separation
function [p, kz, path, work_array]  = path23(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back)
    z_prev = work_array(5);  
    z_2bound = work_array(7);
    z_3bound = work_array(8);
	p_2bound = work_array(18);
    p_prev = work_array(16);	
    
    z0 = (z_2bound + z_3bound)/2;
    zm = (z_2bound-z_3bound)/2;
    p = p_2bound/2 +p_2bound/4*(3*(z-z0)/zm - ((z-z0)/zm)^3);
    kz = p_2bound/4*(3/zm - 3*(z-z0)^2/zm^3);
    path =  23;
   if z > z_prev
		work_array(10) = z_prev;
		work_array(20) = p_prev;
	    [p, kz, path, work_array] = path321(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);
	end 
    if z <= z_3bound
       [p, kz, path, work_array] = path30(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);
	end
end 
