%Path 3-2-1;
%Re-loading after full separation and reversal from partial soil separation curve
function [p, kz, path, work_array] = path321(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back)
    z_prev = work_array(5); 
    z_cubicRev = work_array(10);
    z_1controlDeg = work_array(12);
    p_1bound = work_array(17);
    p_lastRev = work_array(19);
    p_cubicRev = work_array(20);
    p_1controlDeg = work_array(21);
    dp_backbone = work_array(23);
   
    z0 = (z_1controlDeg+z_cubicRev)/2;
    zm = (z_1controlDeg-z_cubicRev)/2;
    p = (p_1controlDeg+p_cubicRev)/2 +(p_1controlDeg-p_cubicRev)/4*(3*(z-z0)/zm -((z-z0)/zm)^3);
    kz = (p_1controlDeg+p_cubicRev)/4*(3/zm - 3*(z-z0)^2/zm^3); 
    path = 321;
	if z >= z_1controlDeg       
		[p, kz, path] = path01(z, d, a_back, b_back, strength_mudline, strength_grad, work_array);    
         work_array(23) = dp_backbone + (p_1controlDeg-p_1bound);
	end 
	if p>p_1bound
       	p = p_1bound;
		kz = 0;
	end 
	if z<z_prev	
       	if p_lastRev>=p_1bound
			work_array(6) = z_lastRev;
			work_array(17) = p_lastRev;	
            [work_array(7), work_array(18), work_array(8)] = revboundingloop(z_lastRev, p_1bound, phi_soil, k0, w_soil, psi_soil);	
            path = 12;
            [p, kz, path] =  path12(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);
        end 
        work_array(13) = iterationCubic(work_array); 
        [work_array(14), work_array(22), work_array(15)] = revboundingloop(work_array(13), p_1bound, phi_soil, k0, w_soil, psi_soil);	
         path = 122;		
		[p, kz, path] = path122(z, work_array, d, phi_soil, strength_mudline,strength_grad, k0, w_soil, psi_soil, a_back,b_back);
	end 			
end		