function z_pmax = iterationCubic(work_array) 
	z_lastRev = work_array(9)
    z_1controlDeg = work_array(12)
    p_1bound = work_array(17)
    p_lastRev = work_array(19)
    p_1controlDeg = work_array(21)
    
    error = -1;
    z0 = (z_1controlDeg+z_lastRev)/2;
    zm = (z_1controlDeg-z_lastRev)/2;
	z = z_lastRev;
    while error <= 0
		z = z + 0.000001;	    
        p = (p_1controlDeg+p_lastRev)/2 +(p_1controlDeg-p_lastRev)/4*(3*(z-z0)/zm - ((z-z0)/zm)^3);
       	error = p - p_1bound;        
    end    
    z_pmax = z;
        
end